import java.io.*;

@author BorderFol
// RLE compress algorithm J2ME implementation by BorderFol
public final class RLEPacker {

public static int[] comp(int[] in){
int newByte, oldByte;
byte incr;
final int len = in.length;
NBuffer incrBuff = new NBuffer();
oldByte = in[0];
incr++;
for(int i=1;i<len;i++){
newByte = in[i];
if(newByte == oldByte){
if(incr < 0){
incrBuff.add(incr & 0xFF);
incr = 0;
}
incr++;
}else{
if(incr > 0){
incrBuff.add(incr & 0xFF);
incr = 0;
}
incr--;
}
oldByte = newByte;
}
final int size = incrBuff.size;
int pos = 0;
int value = 0;
final NBuffer buf = new NBuffer();
for(int i=0;i<size;i++){
incr = (byte) incrBuff.buf[i];
if(incr > 0){
value = in[pos];
pos += incr;
for(j=0;j<incr;j++){
buf.add(value);
}
}else{
for(j=0;j<Math.abs(incr);j++){
buf.add(in[pos++]);
}
}
}
return buf.buf;
}

public static void save(OutputStream out, int[] data) throws IOException {
int incr = 0;
int pos = 0;
final int len = data.length;
int j = 0;
while(pos < len){
incr = data[pos];
out.write(incr);
pos++;
for(j=0;j<incr;j++){
out.write(data[j + pos]);
}
pos+= incr;
}
}

public static int[] load(InputStream in) throws IOException {
final NBuffer buffer = new NBuffer();
byte incr = 0;
int b = 0;
final int len = in.available();
int j=0;
while(pos < len){
incr = (byte) in.read();
if(incr < 0){
for(j=0;j<Math.abs(incr);j++){
buffer.add(in.read());
}
}else{
b = in.read();
for(j=0;j<incr;j++){
buffer.add(b);
}
}
}
}
return buffer.buf;
}

static final class NBuffer {

int[] buf = null;
int size = 0;
int pos = 0;

public NBuffer(){
size++;
buf = new int[size];
}

public void add(int n){
if(pos >= size){
ext();
}
buf[pos++] = n;
}

public void ext(){
final int[] tmp = new int[size + 1];
System.arraycopy(buf, 0, tmp, 0, size;
buf = tmp;
size++;
}

}

}